var tabloc_pref = Components.classes["@mozilla.org/preferences-service;1"]
                                   .getService(Components.interfaces.nsIPrefBranch);
var tabloc_io   = Components.classes['@mozilla.org/network/io-service;1']
                                   .getService(Components.interfaces.nsIIOService);


function tabloc_init() {
	if(!gBrowser){ return; }

	tabloc_addKey("lock_tab_menu",
		tabloc_pref.getCharPref("extensions.tabloc.keymodifiers_lock"),
		tabloc_pref.getCharPref("extensions.tabloc.key_lock"));
	tabloc_addKey("protect_tab_menu",
		tabloc_pref.getCharPref("extensions.tabloc.keymodifiers_protect"),
		tabloc_pref.getCharPref("extensions.tabloc.key_protect"));
	tabloc_addKey("lock_protect_tab_menu",
		tabloc_pref.getCharPref("extensions.tabloc.keymodifiers_lock_protect"),
		tabloc_pref.getCharPref("extensions.tabloc.key_lock_protect"));

	if(tabloc_pref.getBoolPref("extensions.tabloc.add.lock_tab_menu")){
		tabloc_addMenuItem(gBrowser, "lock_tab_menu", 0)
	}
	if(tabloc_pref.getBoolPref("extensions.tabloc.add.protect_tab_menu")){
		tabloc_addMenuItem(gBrowser, "protect_tab_menu", 1);
	}
	if(tabloc_pref.getBoolPref("extensions.tabloc.add.lock_protect_tab_menu")){
		tabloc_addMenuItem(gBrowser, "lock_protect_tab_menu", 2);
	}

	gBrowser.tabContainer.addEventListener("dblclick", tabloc_dblclick, false);

	gBrowser.tabContainer.addEventListener("mousedown", tabloc_mousedown, false);
	gBrowser.tabContainer.addEventListener("mouseup",   tabloc_mouseup, false);

	var menuParent = gBrowser.mStrip.firstChild.nextSibling;
	if(menuParent){
		menuParent.addEventListener("popupshowing", tabloc_updateChecked, false);
	}

	tabloc_override_removeTab();
}

function tabloc_lockTab(aTab) {
	if (aTab.localName != "tab") { aTab = gBrowser.selectedTab; }
	if (tabloc_isIgnoredTab(aTab)) { return; }

	if (aTab.hasAttribute("__tabloc_locked") ) {
		aTab.removeAttribute("__tabloc_locked");
		tabloc_restore_loadURI(gBrowser.getBrowserForTab(aTab));
	} else {
		aTab.setAttribute("__tabloc_locked", "true");
		tabloc_override_loadURI(gBrowser.getBrowserForTab(aTab));
	}
}

function tabloc_protectTab(aTab) {
	if (aTab.localName != "tab") { aTab = gBrowser.selectedTab; }
	if (tabloc_isIgnoredTab(aTab)) { return; }

	if (aTab.hasAttribute("__tabloc_protected")) {
		aTab.removeAttribute("__tabloc_protected");
	} else {
		aTab.setAttribute("__tabloc_protected", "true");
	}
}

function tabloc_lockProtectTab(aTab) {
	if (aTab.localName != "tab") { aTab = gBrowser.selectedTab; }
	if (tabloc_isIgnoredTab(aTab)) { return; }

	if (aTab.hasAttribute("__tabloc_locked") && aTab.hasAttribute("__tabloc_protected")) {
		aTab.removeAttribute("__tabloc_locked");
		aTab.removeAttribute("__tabloc_protected");
		tabloc_restore_loadURI(gBrowser.getBrowserForTab(aTab));
	} else {
		aTab.setAttribute("__tabloc_locked", "true");
		aTab.setAttribute("__tabloc_protected", "true");
		tabloc_override_loadURI(gBrowser.getBrowserForTab(aTab));
	}
}

function tabloc_override_removeTab(){
	var strRemoveTab = gBrowser.removeTab.toString();
	var pos = strRemoveTab.indexOf('{');
	eval("gBrowser.removeTab = " + strRemoveTab.substr(0, pos+1)
	  + "\nif(!tabloc_canRemoveTab(aTab)) { return; }\n"
	  + strRemoveTab.substr(pos+1));
}

function tabloc_override_loadURI(browser){
	browser.addEventListener("click", tabloc_onclick, true);

	if(!browser.__tabloc_loadURI){
		browser.__tabloc_loadURI = browser.loadURI;
		var strLoadURI = browser.loadURI.toString();
		var pos = strLoadURI.indexOf('{');
		eval("browser.loadURI = " + strLoadURI.substr(0, pos+1)
		  + "\nif(gBrowser.selectedTab.hasAttribute(\"__tabloc_locked\")) {\n"
		  + "  var fgtab = tabloc_pref.getBoolPref(\"extensions.tabloc.open_foreground\");\n"
		  + "  gBrowser.loadOneTab(aURI, aReferrerURI, aCharset, null, !fgtab);\n"
		  + "  return;\n"
		  + "}\n"
		  + strLoadURI.substr(pos+1));
	}
	if(!browser.__tabloc_loadURIWithFlags){
		browser.__tabloc_loadURIWithFlags = browser.loadURIWithFlags;
		var strLoadURIWithFlags = browser.loadURIWithFlags.toString();
		var pos = strLoadURIWithFlags.indexOf('{');
		eval("browser.loadURIWithFlags = " + strLoadURIWithFlags.substr(0, pos+1)
		  + "\nif(gBrowser.selectedTab.hasAttribute(\"__tabloc_locked\")) {\n"
		  + "  var fgtab = tabloc_pref.getBoolPref(\"extensions.tabloc.open_foreground\");\n"
		  + "  gBrowser.loadOneTab(aURI, aReferrerURI, aCharset, aPostData, !fgtab);\n"
		  + "  return;\n"
		  + "}\n"
		  + strLoadURIWithFlags.substr(pos+1));
	}
	if(tabloc_pref.getBoolPref("extensions.tabloc.prevent_back_forward")){
		if(!browser.__tabloc_goBack){
			browser.__tabloc_goBack = browser.goBack;
			browser.goBack = tabloc_do_nothing;
		}
		if(!browser.__tabloc_goForward){
			browser.__tabloc_goForward = browser.goForward;
			browser.goForward = tabloc_do_nothing;
		}
	}
}

function tabloc_do_nothing(){
  return;
}

function tabloc_restore_loadURI(browser){
	try{
		if(browser.__tabloc_loadURI){
			browser.loadURI = browser.__tabloc_loadURI;
			delete browser.__tabloc_loadURI;
		}
		if(browser.__tabloc_loadURIWithFlags){
			browser.loadURIWithFlags = browser.__tabloc_loadURIWithFlags;
			delete browser.__tabloc_loadURIWithFlags;
		}
		if(browser.__tabloc_goBack){
			browser.goBack = browser.__tabloc_goBack;
			delete browser.__tabloc_goBack;
		}
		if(browser.__tabloc_goForward){
			browser.goForward = browser.__tabloc_goForward;
			delete browser.__tabloc_goForward;
		}
		browser.removeEventListener("click", tabloc_onclick, true);
	}catch(e){}
}

function tabloc_isIgnoredTab(aTab){
	try{
		if (tabloc_pref.getBoolPref("extensions.tabloc.ex_aboutblank")) {
			var url = gBrowser.getBrowserForTab(aTab).currentURI.spec;
			if(url == "" || url == "about:blank"){
				return true;
			}
		}
	}catch(e){ }
	return false;
} 

function tabloc_canRemoveTab(aTab){
	try{
		if(gBrowser.selectedTab == aTab && 
			tabloc_pref.getBoolPref("extensions.tabloc.close_active")){
			return true;
		}
		if(aTab.hasAttribute("__tabloc_protected")){
			return false;
		}
	}catch(e){ }
	return true;
}

function tabloc_onclick(evt){
	if(evt && evt.target && evt.button == 0){
		var a = evt.target;
		while(a && !a.href && (a.tagName.toLowerCase() != "form")){
			a = a.parentNode;
		}

		if(a && a.href){
			tabloc_href(a, evt);
		}else if(a && a.tagName.toLowerCase() === "form"){
			tabloc_form(a, evt);
		}
	}
}

function tabloc_href(a, evt) {
	if(!gBrowser){ return; }
	var exinpage     = tabloc_pref.getBoolPref("extensions.tabloc.ex_inpagelink");
	var exjavascript = tabloc_pref.getBoolPref("extensions.tabloc.ex_javascript");
	var currentURL   = a.ownerDocument.URL;

	if(exinpage){
		var nowhref = currentURL.split("#")[0];
		if(a.href === nowhref || a.href.indexOf(nowhref + "#") == 0){
			return;
		}
	}
	if(exjavascript){
		if(a.href.indexOf("javascript:") == 0){
			return;
		}
	}

	var fgtab = tabloc_pref.getBoolPref("extensions.tabloc.open_foreground");
	var sendref = tabloc_pref.getBoolPref("extensions.tabloc.send_referer");
	if(sendref){
		var referer = tabloc_io.newURI(currentURL, null, null);
		gBrowser.loadOneTab(a.href, referer, null, null, !fgtab);
	}else{
		gBrowser.loadOneTab(a.href, null, null, null, !fgtab);
	}
	evt.preventDefault();
}

function tabloc_form(a, evt) {
	var exform = tabloc_pref.getBoolPref("extensions.tabloc.ex_formsubmit");
	if(exform){
		return;
	}
	a.setAttribute("__tabloc_target", a.target);
	a.target = "_blank";
	a.ownerDocument.defaultView.setTimeout(tabloc_restore_target, 500, a);
}

function tabloc_restore_target(a){
	if(a.hasAttribute("__tabloc_target")){
		a.target = a.getAttribute("__tabloc_target");
		a.removeAttribute("__tabloc_target");
	}
}

function tabloc_addKey(menuid, modifiers, keycode) {
	var key = document.getElementById("key_" + menuid);
  if(keycode.length == 1){
    key.setAttribute("modifiers", modifiers);
    key.setAttribute("key", keycode);
    key.setAttribute("disabled", false);
  }else if(keycode.length > 1){
    key.setAttribute("modifiers", modifiers);
    key.setAttribute("keycode", "VK_" + keycode);
    key.setAttribute("disabled", false);
  }
}

function tabloc_addMenuItem(contentBrowser, menuid, menuindex) {
	var newMenu = document.getElementById(menuid).cloneNode(false);
	if(!newMenu){ return null; }
	newMenu.id = "tab-" + menuid;
	var menuParent = contentBrowser.mStrip.firstChild.nextSibling;
	var pos = tabloc_pref.getIntPref("extensions.tabloc.menu_pos") + menuindex;
	if(pos >= menuParent.childNodes.length){
	  menuParent.appendChild(newMenu);
	}else{
	  menuParent.insertBefore(newMenu, menuParent.childNodes[pos]);
	}
	return newMenu;
}

function tabloc_dblclick(){
	switch(tabloc_pref.getIntPref("extensions.tabloc.dblclick_action")){
		case 1: tabloc_lockTab(false); break;
		case 2: tabloc_protectTab(false); break;
		case 3: tabloc_lockProtectTab(false); break;
		default: break;
	}
}

var tabloc_mousedown_browser = null;
function tabloc_mousedown(){
	if(!gBrowser){ return; }
	var ctab = gBrowser.selectedTab;
	tabloc_mousedown_browser = gBrowser.selectedBrowser;
	var time = tabloc_pref.getIntPref("extensions.tabloc.longpush_time");
	tabloc_mousedown_browser.__tabloc_timer = tabloc_mousedown_browser.contentWindow.setTimeout(tabloc_longpush, time, ctab);
}

function tabloc_mouseup(){
	if(tabloc_mousedown_browser != null){
		tabloc_mousedown_browser.contentWindow.clearTimeout(tabloc_mousedown_browser.__tabloc_timer);
		delete tabloc_mousedown_browser.__tabloc_timer;
	}
}

function tabloc_longpush(){
	switch(tabloc_pref.getIntPref("extensions.tabloc.longpush_action")){
		case 1: tabloc_lockTab(false); break;
		case 2: tabloc_protectTab(false); break;
		case 3: tabloc_lockProtectTab(false); break;
		default: break;
	}
}

function tabloc_setChecked(id, value) {
	var item = gBrowser.ownerDocument.getElementById(id);
	if(item == null){ return; }
	if(value){
		item.setAttribute("checked", true);
	}else{
		item.removeAttribute("checked");
	}
}

function tabloc_setVisible(id, value) {
	var item = gBrowser.ownerDocument.getElementById(id);
	if(item == null){ return; }
	var style = item.getAttribute("style");
	if(value){
		item.setAttribute("style", style.replace("display: none;",""));
	}else{
		item.setAttribute("style", "display: none;" + style);
	}
}

function tabloc_updateChecked() {
	var aTab = gBrowser.mContextTab;
	if(!aTab){ return; }
	if(tabloc_isIgnoredTab(aTab)){
		tabloc_setVisible("tab-lock_tab_menu", false);
		tabloc_setVisible("tab-protect_tab_menu", false);
		tabloc_setVisible("tab-lock_protect_tab_menu", false);
		return;
	}
	var l = aTab.hasAttribute("__tabloc_locked");
	var p = aTab.hasAttribute("__tabloc_protected");
	tabloc_setChecked("tab-lock_tab_menu", l);
	tabloc_setChecked("tab-protect_tab_menu", p);
	tabloc_setChecked("tab-lock_protect_tab_menu", l && p);
	tabloc_setVisible("tab-lock_tab_menu", true);
	tabloc_setVisible("tab-protect_tab_menu", true);
	tabloc_setVisible("tab-lock_protect_tab_menu", true);
}

